L=6.13;
W= 0.2;
H= 0.61;
theta= -0.2;
J=13;

[fens,gcells] = t4block(L,W,H,6,1,2);

geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
x=get(geom,'values');
u = [-theta*(-x(:,1).^0+2*x(:,1)/L).*x(:,3),0*x(:,1),theta*L*(-x(:,1)/L +x(:,1).^2/L^2)];
u=field(struct ('name',['u'], 'dim', 3, 'data',u));
bg=mesh_bdry(gcells);
    bfeb = feblock(struct ('gcells',bg));
    gv=graphic_viewer;
    gv=reset (gv,[]);
draw(bfeb,gv, struct ('x', geom,'u',u,'facecolor','none'));
bg=mesh_bdry(gcells(J));
    bfeb = feblock(struct ('gcells',bg));
draw(bfeb,gv, struct ('x', geom,'u',u,'facecolor','r'));
        draw_axes(gv,[])
conn =        get(gcells(J),'conn')
x=gather(geom,conn,'values','noreshape')       
U=gather(u,conn,'values','noreshape')       
        
X= [x, ones(4,1)]
A=inv(X);
A(1:3,:)'

Nder = bfundpar (gcells(J), [0,0,0])
Ndersp = bfundsp (gcells(J), Nder, x)

gradN =A(1:3,1)'
B_1 =[gradN(1),0,0;
0,gradN(2),0;
0,0,gradN(3);
gradN(2),gradN(1),0;
gradN(3),0,gradN(1);
0,gradN(3),gradN(2)]
gradN =A(1:3,2)'
B_2 =[gradN(1),0,0;
0,gradN(2),0;
0,0,gradN(3);
gradN(2),gradN(1),0;
gradN(3),0,gradN(1);
0,gradN(3),gradN(2)]
gradN =A(1:3,3)'
B_3 =[gradN(1),0,0;
0,gradN(2),0;
0,0,gradN(3);
gradN(2),gradN(1),0;
gradN(3),0,gradN(1);
0,gradN(3),gradN(2)]
gradN =A(1:3,4)'
B_4 =[gradN(1),0,0;
0,gradN(2),0;
0,0,gradN(3);
gradN(2),gradN(1),0;
gradN(3),0,gradN(1);
0,gradN(3),gradN(2)]

B = Blmat(gcells(1), [0,0,0], x, eye(3))
U=gather(u,conn,'values')

    B*U
B_1*U(1,:)'
